program test_read_eddy

  ! Libraries:
  use mpi_f08, only: mpi_init, mpi_finalize
  use shapelib, only: shpfileobject, shpclose
  use shapelib_03, only: shp_open_03

  use derived_types, only: eddy
  use init_shapefiles_m, only: init_shapefiles
  use read_eddy_m, only: read_eddy
  use read_field_indices_m, only: read_field_indices
  use write_eddy_m, only: write_eddy

  implicit none

  type(eddy) e
  integer k, i
  TYPE(shpfileobject) hshp_extremum ! shapefile extremum
  TYPE(shpfileobject) hshp_outermost ! shapefile outermost_contour
  TYPE(shpfileobject) hshp_max_speed ! shapefile max_speed_contour

  !-------------------------------------------------------------------------

  call mpi_init
  call shp_open_03(hshp_extremum, "SHP_triplet_old/extremum", pszaccess = "rb")
  call shp_open_03(hshp_outermost, "SHP_triplet_old/outermost_contour", &
       pszaccess = "rb")
  call shp_open_03(hshp_max_speed, "SHP_triplet_old/max_speed_contour", &
       pszaccess = "rb")
  call read_field_indices(hshp_extremum, hshp_outermost, hshp_max_speed, &
       rank = 0)
  call read_eddy(e, k, i, hshp_extremum, hshp_outermost, hshp_max_speed, &
       ishape = 0)
  CALL shpclose(hshp_extremum)
  CALL shpclose(hshp_outermost)
  CALL shpclose(hshp_max_speed)

  call init_shapefiles(hshp_extremum, hshp_outermost, hshp_max_speed)
  call write_eddy(e, hshp_extremum, hshp_outermost, hshp_max_speed, k, i)
  CALL shpclose(hshp_extremum)
  print *, 'Created shapefile "extremum".'
  CALL shpclose(hshp_outermost)
  print *, 'Created shapefile "outermost_contour".'
  CALL shpclose(hshp_max_speed)
  print *, 'Created shapefile "max_speed_contour".'
  call mpi_finalize

end program test_read_eddy
